"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createSaga = createSaga;
var _toolkit = require("@reduxjs/toolkit");
var _effects = require("redux-saga/effects");
function getSpawnType(spawnType) {
  switch (spawnType) {
    case 'take':
      return _effects.take;
    case 'takeEvery':
      return _effects.takeEvery;
    case 'takeLatest':
      return _effects.takeLatest;
    case 'takeLeading':
      return _effects.takeLeading;
    case 'takeMaybe':
      return _effects.takeMaybe;
    default:
      return 'takeEvery';
  }
}
function createSaga(options) {
  const {
    name,
    initialState,
    reducers,
    extraReducers,
    sagas
  } = options;
  const newSlice = (0, _toolkit.createSlice)({
    name: name,
    initialState: initialState,
    reducers: reducers,
    extraReducers: extraReducers
  });
  const result = {
    actions: newSlice.actions,
    reducer: newSlice.reducer,
    saga: undefined
  };
  if (sagas && Object.keys(sagas).length > 0) {
    const _saga = function* createNewSaga() {
      yield (0, _effects.all)(Object.keys(sagas).map(sagaName => {
        var _getSpawnType, _sagas$sagaName, _result$actions, _sagas$sagaName2;
        return (_getSpawnType = getSpawnType(sagas === null || sagas === void 0 ? void 0 : (_sagas$sagaName = sagas[sagaName]) === null || _sagas$sagaName === void 0 ? void 0 : _sagas$sagaName.spawnType)) === null || _getSpawnType === void 0 ? void 0 : _getSpawnType((_result$actions = result.actions) === null || _result$actions === void 0 ? void 0 : _result$actions[sagaName], sagas === null || sagas === void 0 ? void 0 : (_sagas$sagaName2 = sagas[sagaName]) === null || _sagas$sagaName2 === void 0 ? void 0 : _sagas$sagaName2.action);
      }).filter(saga => !!saga));
    };
    result.saga = _saga;
  }
  return result;
}
//# sourceMappingURL=create-saga.js.map