"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.connectRepo = exports.ConnectRepository = void 0;
var _toolkit = require("@reduxjs/toolkit");
var _reactNative = require("react-native");
const initialState = {
  isConnected: true,
  appState: _reactNative.AppState.isAvailable ? _reactNative.AppState.currentState : null
};
class ConnectRepository {
  static sliceName = 'connect';
  static instance(initial) {
    if (!ConnectRepository._instance) {
      ConnectRepository._instance = new ConnectRepository(initial);
    }
    return ConnectRepository._instance;
  }
  constructor(initial) {
    if (!initial) {
      this.initialize();
    } else {
      this._slices = initial();
    }
  }
  initialize() {
    this._slices = (0, _toolkit.createSlice)({
      name: ConnectRepository.sliceName,
      initialState,
      reducers: {
        setConnected: (state, action) => {
          return {
            ...state,
            isConnected: action === null || action === void 0 ? void 0 : action.payload
          };
        },
        setAppState: (state, action) => {
          return {
            ...state,
            appState: action === null || action === void 0 ? void 0 : action.payload
          };
        }
      }
    });
  }
  get reducer() {
    return this._slices.reducer;
  }
  get actions() {
    return this._slices.actions;
  }
  get slice() {
    return this._slices;
  }
}
exports.ConnectRepository = ConnectRepository;
const connectRepo = ConnectRepository.instance();
exports.connectRepo = connectRepo;
//# sourceMappingURL=connect-slices.js.map