"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReduxStorageEventListener = void 0;
var _reactNative = require("react-native");
var _enums = require("../enums");
/**
 * error callback function
 *
 * @param data - information error
 * */

/**
 * registered events type
 *
 */

class ReduxStorageEventListenerImpl {
  static instance() {
    if (!ReduxStorageEventListenerImpl._instance) {
      ReduxStorageEventListenerImpl._instance = new ReduxStorageEventListenerImpl();
    }
    return ReduxStorageEventListenerImpl._instance;
  }
  _events = [];
  constructor() {}
  registerEvent(events) {
    if (typeof events !== 'object') {
      return;
    }
    Object.keys(events).forEach(e => {
      const subscriptions = _reactNative.DeviceEventEmitter.addListener(_enums.EventKeys[e], events[e]);
      this._events.push(subscriptions);
    });
  }
  destroyAll() {
    this._events.forEach(event => {
      event.remove();
    });
  }
}
const ReduxStorageEventListener = ReduxStorageEventListenerImpl.instance();
exports.ReduxStorageEventListener = ReduxStorageEventListener;
//# sourceMappingURL=redux-storage-event-listener.js.map