import { createSlice } from '@reduxjs/toolkit';
import { all, take, takeEvery, takeLatest, takeLeading, takeMaybe } from 'redux-saga/effects';
function getSpawnType(spawnType) {
  switch (spawnType) {
    case 'take':
      return take;
    case 'takeEvery':
      return takeEvery;
    case 'takeLatest':
      return takeLatest;
    case 'takeLeading':
      return takeLeading;
    case 'takeMaybe':
      return takeMaybe;
    default:
      return 'takeEvery';
  }
}
export function createSaga(options) {
  const {
    name,
    initialState,
    reducers,
    extraReducers,
    sagas
  } = options;
  const newSlice = createSlice({
    name: name,
    initialState: initialState,
    reducers: reducers,
    extraReducers: extraReducers
  });
  const result = {
    actions: newSlice.actions,
    reducer: newSlice.reducer,
    saga: undefined
  };
  if (sagas && Object.keys(sagas).length > 0) {
    const _saga = function* createNewSaga() {
      yield all(Object.keys(sagas).map(sagaName => {
        var _getSpawnType, _sagas$sagaName, _result$actions, _sagas$sagaName2;
        return (_getSpawnType = getSpawnType(sagas === null || sagas === void 0 ? void 0 : (_sagas$sagaName = sagas[sagaName]) === null || _sagas$sagaName === void 0 ? void 0 : _sagas$sagaName.spawnType)) === null || _getSpawnType === void 0 ? void 0 : _getSpawnType((_result$actions = result.actions) === null || _result$actions === void 0 ? void 0 : _result$actions[sagaName], sagas === null || sagas === void 0 ? void 0 : (_sagas$sagaName2 = sagas[sagaName]) === null || _sagas$sagaName2 === void 0 ? void 0 : _sagas$sagaName2.action);
      }).filter(saga => !!saga));
    };
    result.saga = _saga;
  }
  return result;
}
//# sourceMappingURL=create-saga.js.map