import { PayloadAction, Slice } from '@reduxjs/toolkit';
import { AppStateStatus } from 'react-native';
interface IConnectState {
    isConnected: boolean | null;
    appState: AppStateStatus | null;
}
type IConnectSlice = Slice<IConnectState, {
    setConnected: (state: IConnectState, action: PayloadAction<boolean | null>) => IConnectState | undefined;
    setAppState: (state: IConnectState, action: PayloadAction<AppStateStatus | null>) => IConnectState | undefined;
}, string>;
declare class ConnectRepository {
    private static sliceName;
    private static _instance?;
    static instance(initial?: () => IConnectSlice): ConnectRepository;
    private _slices;
    constructor(initial?: () => IConnectSlice);
    private initialize;
    get reducer(): import("redux").Reducer<IConnectState, import("redux").AnyAction>;
    get actions(): import("@reduxjs/toolkit").CaseReducerActions<{
        setConnected: (state: IConnectState, action: {
            payload: boolean | null;
            type: string;
        }) => IConnectState | undefined;
        setAppState: (state: IConnectState, action: {
            payload: AppStateStatus | null;
            type: string;
        }) => IConnectState | undefined;
    }, string>;
    get slice(): IConnectSlice | undefined;
}
declare const connectRepo: ConnectRepository;
export { ConnectRepository, connectRepo, IConnectState, IConnectSlice };
//# sourceMappingURL=connect-slices.d.ts.map