import { PayloadAction, Slice } from '@reduxjs/toolkit';
type IActions = Record<string, boolean>;
type ICacheActions = Record<string, any>;
interface ILoadingState {
    loadingActions: IActions;
    fetchingActions: IActions;
    cachingActions: ICacheActions;
}
type ILoadingSlice = Slice<ILoadingState, {
    showLoading: (state: ILoadingState, action: PayloadAction<string>) => ILoadingState | undefined;
    hideLoading: (state: ILoadingState, action: PayloadAction<string>) => ILoadingState | undefined;
    onFetching: (state: ILoadingState, action: PayloadAction<string>) => ILoadingState | undefined;
    nonFetching: (state: ILoadingState, action: PayloadAction<string>) => ILoadingState | undefined;
    onCaching: (state: ILoadingState, action: PayloadAction<{
        type: string;
        payload: any;
    }>) => ILoadingState | undefined;
}, string>;
declare class LoadingRepository {
    private static sliceName;
    private static _instance?;
    static instance(initial?: () => ILoadingSlice): LoadingRepository;
    private _slices;
    constructor(initial?: () => ILoadingSlice);
    private initialize;
    private addAction;
    private removeAction;
    private addCachingAction;
    get reducer(): import("redux").Reducer<ILoadingState, import("redux").AnyAction>;
    get actions(): import("@reduxjs/toolkit").CaseReducerActions<{
        showLoading: (state: ILoadingState, action: {
            payload: string;
            type: string;
        }) => ILoadingState | undefined;
        hideLoading: (state: ILoadingState, action: {
            payload: string;
            type: string;
        }) => ILoadingState | undefined;
        onFetching: (state: ILoadingState, action: {
            payload: string;
            type: string;
        }) => ILoadingState | undefined;
        nonFetching: (state: ILoadingState, action: {
            payload: string;
            type: string;
        }) => ILoadingState | undefined;
        onCaching: (state: ILoadingState, action: {
            payload: {
                type: string;
                payload: any;
            };
            type: string;
        }) => ILoadingState | undefined;
    }, string>;
    get slice(): ILoadingSlice | undefined;
}
declare const loadingRepo: LoadingRepository;
export { LoadingRepository, loadingRepo, ILoadingState, ILoadingSlice };
//# sourceMappingURL=loading-slices.d.ts.map